﻿using System;
using System.Windows.Forms;
using System.IO;
using static System.Windows.Forms.LinkLabel;


namespace pliki_a_tablice_cz2
{
    public partial class Form1 : Form
    {
        int[] tab1, tab2;
        int[,] tab2D;
        Random los = new Random();

        int[] BudujTablice(int w, int zakresLosowan)
        {
            int[] t = new int[w];
            for (int i = 0; i < t.GetLength(0); i++) t[i] = los.Next(zakresLosowan) + 1;
            return t;
        }
        //przeciążenie powyższej funkcji
        int[,] BudujTablice(int w,int k, int zakresLosowan)
        {
            int[,] t = new int[w, k];
            for (int i = 0; i < t.GetLength(0); i++)
                for (int j = 0; j < t.GetLength(1); j++)
                    t[i, j] = los.Next(zakresLosowan) + 1;
            return t;
        }

        void PokazTablice(int[] t,TextBox tb,string naglowek)
        {
            tb.AppendText(naglowek + Environment.NewLine);
            String s = "";
            for (int i = 0; i < t.GetLength(0); i++)
                s += String.Format("{0} ", t[i]);
            tb.AppendText(s + Environment.NewLine);
        }
        //przeciążenie powyższej funkcji
        void PokazTablice(int[,] t, TextBox tb, string naglowek)
        {
            tb.AppendText(naglowek + Environment.NewLine);
            for (int i = 0; i < t.GetLength(0); i++)
            {
                String s = "";
                for (int j = 0; j < t.GetLength(1); j++)
                    s += String.Format("{0} ", t[i, j]);
                tb.AppendText(s + Environment.NewLine);
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            int n = Convert.ToInt32(textBox1.Text);
            tab1 = BudujTablice(n, 20);
            tab2 = BudujTablice(n, 50);
            n = Convert.ToInt32(textBox2.Text);
            tab2D = BudujTablice(n, 2, 50);
            PokazTablice(tab1, textBox3, "tablica tab1:");
            PokazTablice(tab2, textBox3, "tablica tab2:");
            PokazTablice(tab2D, textBox3, "tablica dwuwymiarowa tab2D:");
        }

        void ZapiszTabliceDoPliku(StreamWriter p,int[] t)
        {
            int i = 0;
            //zmienna p to strumień klasy plik
            do
            {
                p.Write(String.Format("{0} ", t[i]));
                i++;
            } while (i < t.GetLength(0));
        }
        //przeciążenie powyższej funkcji
        void ZapiszTabliceDoPliku(StreamWriter p, int[,] t)
        {
            int i = 0;
            //zmienna p to strumień klasy plik
            do
            {
                //zapamietaj jeden wiersz tablicy dwuwymiarowej
                string s = "";
                for(int j=0;j<t.GetLength(1);j++)
                   s+=String.Format("{0} ", t[i,j]);
                //zapisz i przejdź do nowego wiersza
                p.WriteLine(s);
                i++;
            } while (i < t.GetLength(0));
        }
        void ZapiszTabliceDoPlikuZRozmiarem(StreamWriter p, int[] t)
        {
            //przed danymi tablicy zapisz rozmiar tablicy jednowymiarowej
            p.WriteLine(String.Format("{0} ", t.GetLength(0)));
            int i = 0;
            //zmienna p to strumień klasy plik
            do
            {
                p.Write(String.Format("{0} ", t[i]));
                i++;
            } while (i < t.GetLength(0));
        }
        //przeciążenie powyższej funkcji
        void ZapiszTabliceDoPlikuZRozmiarem(StreamWriter p, int[,] t)
        {
            //przed danymi tablicy zapisz rozmiar tablicy dwuwymiarowej
            p.WriteLine(String.Format("{0} {1} ", t.GetLength(0), t.GetLength(1)));
            int i = 0;
            //zmienna p to strumień klasy plik
            do
            {
                //zapamietaj jeden wiersz tablicy dwuwymiarowej
                string s = "";
                for (int j = 0; j < t.GetLength(1); j++)
                    s += String.Format("{0} ", t[i, j]);
                //zapisz i przejdź do nowego wiersza
                p.WriteLine(s);
                i++;
            } while (i < t.GetLength(0));
        }
        int[] BudujTabliceZLinii(string linia)
        {
            string[]s=linia.Split(' ');
            //odejmij 1 bo ostatni znak to spacja
            int[] t = new int[s.Length-1];
            for (int j = 0; j < t.GetLength(0); j++)
                t[j] = Convert.ToInt32(s[j]);
            return t;
        }
        //przeciążenie powyższej funkcji
        int[,] BudujTabliceZLinii(string linia1,string linia2)
        {
            string[] kolumna1 = linia1.Split(' ');
            string[] kolumna2 = linia2.Split(' ');
            //odejmij 1 bo ostatni znak to spacja
            int[,] t = new int[kolumna1.Length - 1,2];
            for (int j = 0; j < t.GetLength(0); j++)
            {
                t[j, 0] = Convert.ToInt32(kolumna1[j]);
                t[j, 1] = Convert.ToInt32(kolumna2[j]);
            }
            return t;
        }

       
        
        private void zapiszTabliceDoPlikuToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //ustaw filtr plików
            saveFileDialog1.Filter = "Pliki tekstowe .txt|*.txt|Wszystkie pliki *.*|*.*";
            //ustaw tytuł okna zapisu dialogowego
            saveFileDialog1.Title = "Zapisz zawartość";
            //narzuć filtr podstawowy
            saveFileDialog1.DefaultExt = "txt";
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                //false- nadpisze plik jak istnieje
                //true- dopisze do pliku jak istnieje
                StreamWriter plik = new StreamWriter(saveFileDialog1.FileName, false);
                ZapiszTabliceDoPliku(plik, tab1);
                plik.Write(Environment.NewLine);
                ZapiszTabliceDoPliku(plik, tab2);
                plik.Write(Environment.NewLine);
                ZapiszTabliceDoPliku(plik, tab2D);
                plik.Close();
                toolStripStatusLabel1.Text = saveFileDialog1.FileName;
            }
        }

        private void pobierzTablicęZPlikuToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //ustaw filtr plików
            openFileDialog1.Filter = "Pliki tekstowe .txt|*.txt|Wszystkie pliki *.*|*.*";
            //ustaw tytuł okna zapisu dialogowego
            openFileDialog1.Title = "Otwórz plik";
            //narzuć filtr podstawowy
            openFileDialog1.DefaultExt = "txt";
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                //buduj tablice z odczytanych linii pliku tekstowego
                StreamReader plik = new StreamReader(openFileDialog1.FileName);
                string linia="",s1="",s2="";
                int i = 0;
                while ((linia = plik.ReadLine()) != null)
                {
                    if (i == 0) { 
                        tab1 = BudujTabliceZLinii(linia);
                        PokazTablice(tab1, textBox3, "tablica tab1 odczytana z pliku:");
                    }
                    if (i == 1)
                    {
                        tab2 = BudujTabliceZLinii(linia);
                        PokazTablice(tab2, textBox3, "tablica tab2 odczytana z pliku:");
                    }
                    //tablicę dwuwymiarową zapisaną w kolejnych wierszach bez podania
                    //poczatkowego rozmiaru zbudujemy posrednio z łancuchów znaków czytanych
                    //linia po linii
                    if (i > 1)
                    {
                        string[] s = linia.Split(' ');
                        s1+= s[0]+" ";
                        s2+= s[1]+" ";
                    }
                    i++;
                }
                plik.Close();
                //odczytałeś wszystkie linie to zbuduj tablicę dwuwymiarową
                tab2D=BudujTabliceZLinii(s1, s2);
                PokazTablice(tab2D, textBox3, "tablica dwuwymiarowa tab2D odczytana z pliku:");
                toolStripStatusLabel1.Text = openFileDialog1.FileName;
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            int n = Convert.ToInt32(textBox5.Text);
            tab1 = BudujTablice(n, 20);
            tab2 = BudujTablice(n, 50);
            n = Convert.ToInt32(textBox4.Text);
            int k = Convert.ToInt32(textBox6.Text);
            tab2D = BudujTablice(n, k, 50);
            PokazTablice(tab1, textBox3, "tablica tab1:");
            PokazTablice(tab2, textBox3, "tablica tab2:");
            PokazTablice(tab2D, textBox3, "tablica dwuwymiarowa tab2D:");
        }

        private void zapiszZRozmiaremToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //zapisuje tablicę jednowymiarową do pliku
            //ustaw filtr plików
            saveFileDialog1.Filter = "Pliki tekstowe .txt|*.txt|Wszystkie pliki *.*|*.*";
            //ustaw tytuł okna zapisu dialogowego
            saveFileDialog1.Title = "Zapisz zawartość";
            //narzuć filtr podstawowy
            saveFileDialog1.DefaultExt = "txt";
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                //false- nadpisze plik jak istnieje
                //true- dopisze do pliku jak istnieje
                StreamWriter plik = new StreamWriter(saveFileDialog1.FileName, false);
                ZapiszTabliceDoPlikuZRozmiarem(plik, tab1);
                plik.Close();
                toolStripStatusLabel1.Text = saveFileDialog1.FileName;
            }
        }

        private void toolStripMenuItem2_Click(object sender, EventArgs e)
        {
            //zapisuje tablice dwuwymiarową do pliku
            //ustaw filtr plików
            saveFileDialog1.Filter = "Pliki tekstowe .txt|*.txt|Wszystkie pliki *.*|*.*";
            //ustaw tytuł okna zapisu dialogowego
            saveFileDialog1.Title = "Zapisz zawartość";
            //narzuć filtr podstawowy
            saveFileDialog1.DefaultExt = "txt";
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                //false- nadpisze plik jak istnieje
                //true- dopisze do pliku jak istnieje
                StreamWriter plik = new StreamWriter(saveFileDialog1.FileName, false);
                ZapiszTabliceDoPlikuZRozmiarem(plik, tab2D);
                plik.Close();
                toolStripStatusLabel1.Text = saveFileDialog1.FileName;
            }

        }

        private void pobierzTablicęZRozmiaremZPlikuToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //ustaw filtr plików
            openFileDialog1.Filter = "Pliki tekstowe .txt|*.txt|Wszystkie pliki *.*|*.*";
            //ustaw tytuł okna zapisu dialogowego
            openFileDialog1.Title = "Otwórz plik";
            //narzuć filtr podstawowy
            openFileDialog1.DefaultExt = "txt";
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                //buduj tablice z odczytanych linii pliku tekstowego
                StreamReader plik = new StreamReader(openFileDialog1.FileName);
                //pierwsza linia to rozmiar tablicy
                string roz = plik.ReadLine();
                int n = Convert.ToInt32(roz);
                tab1= new int[n];
                string linia;
                //czytaj plik dopóki linie nie są puste
                while ((linia=plik.ReadLine()) != null)
                {
                    string[] s = linia.Split(' ');
                    for(int j=0; j< tab1.GetLength(0); j++) tab1[j] = Convert.ToInt32(s[j]);  
                }
                plik.Close();
            }
            PokazTablice(tab1, textBox3, "tablica jednowymiarowa odczytana z pliku:");
        }

        private void toolStripMenuItem3_Click(object sender, EventArgs e)
        {
            //ustaw filtr plików
            openFileDialog1.Filter = "Pliki tekstowe .txt|*.txt|Wszystkie pliki *.*|*.*";
            //ustaw tytuł okna zapisu dialogowego
            openFileDialog1.Title = "Otwórz plik";
            //narzuć filtr podstawowy
            openFileDialog1.DefaultExt = "txt";
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                //buduj tablice z odczytanych linii pliku tekstowego
                StreamReader plik = new StreamReader(openFileDialog1.FileName);
                //pierwsza linia to rozmiar tablicy
                string[] roz = plik.ReadLine().Split(' ');
                int w = Convert.ToInt32(roz[0]);
                int k = Convert.ToInt32(roz[1]);
                tab2D = new int[w,k];
                string linia;
                int i = 0;
                //czytaj plik dopóki linie nie są puste
                while ((linia = plik.ReadLine()) != null)
                {
                    string[] s = linia.Split(' ');
                    for (int j = 0; j < tab2D.GetLength(1); j++) tab2D[i,j] = Convert.ToInt32(s[j]);
                    i++;
                }
                plik.Close();
            }
            PokazTablice(tab2D, textBox3, "tablica dwuwymiarowa odczytana z pliku:");
        }

        private void button3_Click(object sender, EventArgs e)
        {

        }

        private void zapiszJednowymiarowaWKolumnieToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //zapisuje tablicę jednowymiarową do pliku
            //ustaw filtr plików
            saveFileDialog1.Filter = "Pliki tekstowe .txt|*.txt|Wszystkie pliki *.*|*.*";
            //ustaw tytuł okna zapisu dialogowego
            saveFileDialog1.Title = "Zapisz zawartość";
            //narzuć filtr podstawowy
            saveFileDialog1.DefaultExt = "txt";
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                //false- nadpisze plik jak istnieje
                //true- dopisze do pliku jak istnieje
                StreamWriter plik = new StreamWriter(saveFileDialog1.FileName, false);
                //przed danymi tablicy zapisz rozmiar tablicy jednowymiarowej
                plik.WriteLine(String.Format("{0}", tab1.GetLength(0)));
                int i = 0;
                do
                {
                    plik.WriteLine(String.Format("{0}", tab1[i]));
                    i++;
                } while (i < tab1.GetLength(0));
                plik.Close();
                toolStripStatusLabel1.Text = saveFileDialog1.FileName;
            }

        }

        private void odczytajJednowymiarowaZKolumnyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //ustaw filtr plików
            openFileDialog1.Filter = "Pliki tekstowe .txt|*.txt|Wszystkie pliki *.*|*.*";
            //ustaw tytuł okna zapisu dialogowego
            openFileDialog1.Title = "Otwórz plik";
            //narzuć filtr podstawowy
            openFileDialog1.DefaultExt = "txt";
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                //buduj tablice z odczytanych linii pliku tekstowego
                StreamReader plik = new StreamReader(openFileDialog1.FileName);
                //pierwsza linia to rozmiar tablicy
                string roz = plik.ReadLine();
                int n = Convert.ToInt32(roz);
                tab1 = new int[n];
                string linia;
                int i = 0;
                //czytaj plik dopóki linie nie są puste
                while ((linia = plik.ReadLine()) != null)
                {
                    tab1[i] = Convert.ToInt32(linia);
                    i++;
                }
                plik.Close();
                PokazTablice(tab1, textBox3, "tablica jednowymiarowa odczytana z pliku:");
            }
        }

        public Form1()
        {
            InitializeComponent();
        }

        
    }
}
